package com.geobioboo.twitterproj2;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class FilterTweets {

	/**
	 * basically twitterstream, except it removes foreign languages and blank lines.
	 * may have false positives for foreign language, since it matches on ???
	 * where a valid tweet could be 'where are my keys???'
	 * also gets rid of http:// links within the links (but leaves the rest of tweet)
	 * and strips RT at the front of a line
	 */
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader("twitterStream.txt"));
        String line;
        
        Pattern p = Pattern.compile("https{0,1}://t.co/{0,1}\\w*");
        Pattern p2 = Pattern.compile("https{0,1}://tinyurl.com/{0,1}\\w*");
        Pattern p3 = Pattern.compile("^RT:{0,1} @", Pattern.CASE_INSENSITIVE);
        Pattern p4 = Pattern.compile("\\bRT:{0,1} @", Pattern.CASE_INSENSITIVE);
        Pattern p5 = Pattern.compile("[a-z]RT:{0,1} @");
		Matcher m, m2, m3, m4, m5;
        
        while ((line = br.readLine()) != null) {
        	if (line.contains("???") || line.length() == 0) {
        		
        	} else {
        		String lineToWrite = line;
        		
        		m = p.matcher(lineToWrite);
        		while (m.find()) { // while url in link
        			String link = m.group();
            		lineToWrite = lineToWrite.replace(link, "");
        		}
        		m2 = p2.matcher(lineToWrite);
        		while (m2.find()) { // while url in link
        			String link = m2.group();
            		lineToWrite = lineToWrite.replace(link, "");
        		}
        		m3 = p3.matcher(lineToWrite);
        		while (m3.find()) { // while RT @person
        			String link = m3.group();
            		lineToWrite = lineToWrite.replace(link, "@");
        		}
        		m4 = p4.matcher(lineToWrite);
        		while (m4.find()) { // while RT @person
        			String link = m4.group();
            		lineToWrite = lineToWrite.replace(link, "@");
        		}
        		m5 = p5.matcher(lineToWrite);
        		while (m5.find()) { // while RT @person
        			String link = m5.group();
            		lineToWrite = lineToWrite.replace(link, "@");
        		}
        		write(lineToWrite + "\n");
        	}
        }
        endWrite();
        System.out.println("done!");
	}
	
	static FileWriter fw;
    
    private static void write(String s) {
    	try {
    		if (fw == null)
    			fw = new FileWriter("twitterStreamFiltered.txt", false);
    		fw.write(s);
    	} catch (IOException e) {}
    }
    
    private static void endWrite() {
    	try {
    		fw.close();
    	} catch (IOException e) {}
    }

}
