package com.geobioboo.twitterproj2;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Map.Entry;

import twitter4j.ResponseList;
import twitter4j.Twitter;
import twitter4j.TwitterFactory;
import twitter4j.User;

public class InfoAboutIntersection {
	
	/**
	 * returns the count of each word in a hash table or arraylist
	 * each word is using java's regex for \w (which is alphanumeric)
	 * @ when used before a word is treated as a username, and # is accepted as tag
	 */
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("intersection.txt"));
		
		Twitter twitter = new TwitterFactory().getInstance();
		
		final int usersToLookup = 100;
		final long[] oneHundredUsers = new long[100];
		
		ArrayList<User> allUserResults = new ArrayList<User>();
		
		// adds each user to an array, and every 100 users, look it up against twitter api,
		// and save those users into allUserResults arraylist.
        for (int i = 0; i < usersToLookup; i++) {
        	String rawUserId = br.readLine();
        	Long userId;
        	if (rawUserId != "") {
        		userId = Long.valueOf(rawUserId);
        		oneHundredUsers[i % 100] = userId;
        	}
        	if (i == usersToLookup - 1 || i % 100 == 99) { // every 100 users, or at end
        		ResponseList<User> oneHundredUsersResult = twitter.lookupUsers(oneHundredUsers);
        		allUserResults.addAll(oneHundredUsersResult);
        	}
        }
        
        
        for (User u : allUserResults) {
        	String status = u.getStatus() != null ? u.getStatus().getText() : "";
        	status = status.replaceAll("\n", " ");
        	write(u.getScreenName() + "\t" + u.getName() + "\t" + u.getLocation() + "\t" 
        			+ status + "\n");
        }
        endWrite();
	}
	
	static FileWriter fw;
    
    private static void write(String s) {
    	try {
    		if (fw == null)
    			fw = new FileWriter("info_about_intersection.txt", false);
    		fw.write(s);
    	} catch (IOException e) {}
    }
    
    private static void endWrite() {
    	try {
    		fw.close();
    	} catch (IOException e) {}
    }

}