package com.geobioboo.twitterproj2;

import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;

import twitter4j.IDs;
import twitter4j.Twitter;
import twitter4j.TwitterException;
import twitter4j.TwitterFactory;

public class UserIntersection {

	/**
	 * twitter assignment 2, part 2h (or 2b, though its labeled 2h)
	 * saves the user ids of the followers of fredwilson and mikebloomberg
	 * into the files (see below in the write methods).
	 */
	public static void main(String[] args) throws TwitterException {
		final Twitter twitter = new TwitterFactory().getInstance();
		final String user1 = "fredwilson"; // Entrepreneur/VC
		final String user2 = "MikeBloomberg"; // Mayor of New York
		long user1cursor = -1;
		long user2cursor = -1;
		final ArrayList<Long> user1followers = new ArrayList<Long>(110000);
		final ArrayList<Long> user2followers = new ArrayList<Long>(110000);
		
		while (user1cursor != 0 && user1followers.size() < 100000) { // Doesn't try for more than 100k
			final IDs user1ids = twitter.getFollowersIDs(user1, user1cursor);
			user1cursor = user1ids.getNextCursor();
			final long[] user1PartialFollowers = user1ids.getIDs();
			for (long user : user1PartialFollowers) {
				user1followers.add(user);
				writeUser1(String.valueOf(user));
			}
			System.out.println("Downloaded " + user1followers.size() + " users for " + user1);
		}
		
		while (user2cursor != 0 && user2followers.size() < 100000) { // Doesn't try for more than 100k
			final IDs user2ids = twitter.getFollowersIDs(user2, user2cursor);
			user2cursor = user2ids.getNextCursor();
			final long[] user2PartialFollowers = user2ids.getIDs();
			for (long user : user2PartialFollowers) {
				user2followers.add(user);
				writeUser2(String.valueOf(user));
			}
			System.out.println("Downloaded " + user2followers.size() + " users for " + user2);
		}
		
		final ArrayList<Long> intersection = new ArrayList<Long>();
		final HashSet<Long> user1followersHash = new HashSet<Long>(user1followers);
		for (Long user2follower : user2followers) {
			if (user1followersHash.contains(user2follower)) {
				intersection.add(user2follower);
				writeIntersection(String.valueOf(user2follower));
			}
		}
		
		endWrite();
		
		
	}

    static FileWriter fw1, fw2, fwinter;
    
    private static void writeUser1(String s) {
    	try {
    		if (fw1 == null)
    			fw1 = new FileWriter("fredfollowers.txt", false);
    		fw1.write(s + "\n");
    	} catch (IOException e) {}
    }
    
    private static void writeUser2(String s) {
    	try {
    		if (fw2 == null)
    			fw2 = new FileWriter("bloombergfollowers.txt", false);
    		fw2.write(s + "\n");
    	} catch (IOException e) {}
    }
    
    private static void writeIntersection(String s) {
    	try {
    		if (fwinter == null)
    			fwinter = new FileWriter("intersection.txt", false);
    		fwinter.write(s + "\n");
    	} catch (IOException e) {}
    }
    
    private static void endWrite() {
    	try {
    		fw1.close();
    		fw2.close();
    		fwinter.close();
    	} catch (IOException e) {}
    }
}
